//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

#include <tigcclib.h>

//-----------------------------------------------------------------------------

enum {N1,N2,N3,N4,N5,N6,N7,N8,N9};

//-----------------------------------------------------------------------------

int IsDivisor(int D, int M);
int IsSolution(void);
int GetCorrectValues(void);
void ChooseValue(int rank);
void DrawScreen(void);

//-----------------------------------------------------------------------------

int V[9]={1,2,3,4,5,6,7,8,9}; // Values
int C[9]={0,0,0,0,0,0,0,0,0}; // Correct Values

// Cursor Position
int cx=1;
int cy=1;

//-----------------------------------------------------------------------------

// Research Data

int U[9]={0,0,0,0,0,0,0,0,0}; // Used Values

long SolutionsTested;
int SolutionFound_AI;
int ExitResearch;

//-----------------------------------------------------------------------------

unsigned long hexagon_data[96] =
{
    0x00018000, 0x00066000, 0x00181800, 0x00200400, 
    0x00C00300, 0x01000080, 0x06000060, 0x18000018, 
    0x20000004, 0x20000004, 0x20000004, 0x20000004, 
    0x20000004, 0x20000004, 0x20000004, 0x20000004, 
    0x20000004, 0x20000004, 0x20000004, 0x20000004, 
    0x20000004, 0x20000004, 0x20000004, 0x20000004, 
    0x18000018, 0x06000060, 0x01000080, 0x00C00300, 
    0x00200400, 0x00181800, 0x00066000, 0x00018000, 
    0x00018000, 0x0007E000, 0x001FF800, 0x003FFC00, 
    0x00FFFF00, 0x01FFFF80, 0x07FFFFE0, 0x1FFFFFF8, 
    0x3FFFFFFC, 0x3FFFFFFC, 0x3FFFFFFC, 0x3FFFFFFC, 
    0x3FFFFFFC, 0x3FFFFFFC, 0x3FFFFFFC, 0x3FFFFFFC, 
    0x3FFFFFFC, 0x3FFFFFFC, 0x3FFFFFFC, 0x3FFFFFFC, 
    0x3FFFFFFC, 0x3FFFFFFC, 0x3FFFFFFC, 0x3FFFFFFC, 
    0x1FFFFFF8, 0x07FFFFE0, 0x01FFFF80, 0x00FFFF00, 
    0x003FFC00, 0x001FF800, 0x0007E000, 0x00018000, 
    0x00018000, 0x00066000, 0x00199800, 0x00266400, 
    0x00D99B00, 0x01266480, 0x06D81B60, 0x19200498, 
    0x26C00364, 0x29000094, 0x2A000054, 0x2A000054, 
    0x2A000054, 0x2A000054, 0x2A000054, 0x2A000054, 
    0x2A000054, 0x2A000054, 0x2A000054, 0x2A000054, 
    0x2A000054, 0x2A000054, 0x29000094, 0x26C00364, 
    0x19200498, 0x06D81B60, 0x01266480, 0x00D99B00, 
    0x00266400, 0x00199800, 0x00066000, 0x00018000, 
} ;

//-----------------------------------------------------------------------------

int IsDivisor(int D, int M)
{
	
	if (D==1)
	return 1;
	
	register int DS=D;
	
	for (;;)
	{
		if (D==M)
		return 1;
		else if (D>M)
		return 0;
		D+=DS;
	}
	
}
//-----------------------------------------------------------------------------

int IsSolution(void)
{
	
	// Wrong Values ?
	if (!IsDivisor(V[N1],V[N2]+V[N4]                        )) return 0;
	if (!IsDivisor(V[N2],V[N1]+V[N3]+V[N4]+V[N5]            )) return 0;
	if (!IsDivisor(V[N3],V[N2]+V[N5]+V[N6]                  )) return 0;
	if (!IsDivisor(V[N4],V[N1]+V[N2]+V[N5]+V[N7]            )) return 0;
	if (!IsDivisor(V[N5],V[N2]+V[N3]+V[N4]+V[N6]+V[N7]+V[N8])) return 0;
	if (!IsDivisor(V[N6],V[N3]+V[N5]+V[N8]+V[N9]            )) return 0;
	if (!IsDivisor(V[N7],V[N4]+V[N5]+V[N8]                  )) return 0;
	if (!IsDivisor(V[N8],V[N5]+V[N6]+V[N7]+V[N9]            )) return 0;
	if (!IsDivisor(V[N9],V[N6]+V[N8]                        )) return 0;
	
	// Else, Solution Found
	return 1;
	
	
}

//-----------------------------------------------------------------------------

int GetCorrectValues(void)
{
	
	// Wrong Values ?
	C[N1] = IsDivisor(V[N1],V[N2]+V[N4]                        );
	C[N2] = IsDivisor(V[N2],V[N1]+V[N3]+V[N4]+V[N5]            );
	C[N3] = IsDivisor(V[N3],V[N2]+V[N5]+V[N6]                  );
	C[N4] = IsDivisor(V[N4],V[N1]+V[N2]+V[N5]+V[N7]            );
	C[N5] = IsDivisor(V[N5],V[N2]+V[N3]+V[N4]+V[N6]+V[N7]+V[N8]);
	C[N6] = IsDivisor(V[N6],V[N3]+V[N5]+V[N8]+V[N9]            );
	C[N7] = IsDivisor(V[N7],V[N4]+V[N5]+V[N8]                  );
	C[N8] = IsDivisor(V[N8],V[N5]+V[N6]+V[N7]+V[N9]            );
	C[N9] = IsDivisor(V[N9],V[N6]+V[N8]                        );
	
	int a;
	for (a=0;a<9;a++)
	if (!C[a])
	return 0;
	
	// Else, Solution Found
	return 1;
	
}

//-----------------------------------------------------------------------------

void ChooseValue(int rank)
{
	
	register int a,b,c;
	register int Count;
	
	for (a=0;a<9-rank;a++)
	{
		
		// Exit Research If Solution Found
		if (ExitResearch)
		break;
		
		
		// Get "a-th" Value Not Used
		Count=0;
		
		for (b=0;b<9;b++)
		{
			if (!U[b])
			{
				if (Count==a)
				break;
				Count++;
			}
		}
		
		// Write Value
		V[rank]=(b+1);
		
		// Set Value As USED
		U[b]=1;
		
		// If all values are choosed, test solution
		if (rank==8)
		{
			
			SolutionsTested++;
			SolutionFound_AI=IsSolution();
			
			if (SolutionFound_AI || (!(SolutionsTested&4095))) // Display 1/4096 tests
			{
				
				for (c=0;c<9;c++)
				printf("%c",'0'+V[c]);
				printf(" %06ld %s \n",SolutionsTested,SolutionFound_AI?"OK":"Wrong");
				
				if (SolutionFound_AI)
				{
					printf("[ENTER] : Continue \n");
					printf("[ESC]   : Exit \n");
					
					GKeyFlush (); // Cancel keystrokes during searching
					int key2;
					while ((key2=ngetchx())!=KEY_ENTER && key2!=KEY_ESC);
					
					if (key2==KEY_ESC)
					ExitResearch=1;
					
				}
			}
			
		}
		else
		ChooseValue(rank+1); // Choose next rank value
		
		// Set Value As UNUSED
		U[b]=0;
		
		
	}
	
}
//-----------------------------------------------------------------------------

void DrawScreen(void)
{

	
	// Get Correct Values
	int SolutionFound=GetCorrectValues();
	
	// Draw Puzzle
	
	ClrScr();

	int x,y;
	int xx,yy;
	
	for (x=0;x<3;x++)
	for (y=0;y<3;y++)
	{
		
		xx=28*x+(14*y);
		yy=24*y;
		
		unsigned long *src=(C[3*y+x]?(hexagon_data+64):hexagon_data);
		Sprite32(xx,yy,32,src,LCD_MEM,SPRT_OR);
		DrawChar(xx+12,yy+12,'0'+V[3*y+x],A_NORMAL);
		
		// If Select Value -> Draw Cursor
		if (x==cx && y==cy)
		Sprite32(xx,yy,32,hexagon_data+32,LCD_MEM,SPRT_XOR);

	}
	
	
	if (SolutionFound)
	DrawStr(0,92,"You Win!",A_NORMAL);

}
//-----------------------------------------------------------------------------

// Main Function
void _main(void)
{
	
	clrscr();
	FontSetSys(0);
	printf("HexaPuzz 1.0 \n");
	printf("Programmed by Olivier Sangala \n");
	printf("http://olivier.sangala.free.fr \n");
	printf("olivier_sangala@hotmail.com \n");
	FontSetSys(1);
	ngetchx();
	
	
	for (;;)
	{
	
		DrawScreen();
		
		int key=ngetchx();
		
		if (key==KEY_LEFT)
		{cx--;if (cx<0) cx=2;}
		else if (key==KEY_RIGHT)
		{cx++;if (cx>2) cx=0;}
		else if (key==KEY_UP)
		{cy--;if (cy<0) cy=2;}
		else if (key==KEY_DOWN)
		{cy++;if (cy>2) cy=0;}
		
		else if (key>='1' && key<='9')
		{
			int rank1=3*cy+cx;
			int rank2=0;
			int num=key-'0';
			
			if (num!=V[rank1])
			{
				int a;
				for (a=0;a<9;a++)
				if (num==V[a])
				rank2=a;
				
				int temp=V[rank1];
				V[rank1]=V[rank2];
				V[rank2]=temp;
			}
			
		}

		else if (key==KEY_F1)
		{
			clrscr();
			
			printf("[ENTER] : Find Solution \n");
			printf("[ESC]   : Cancel \n");
			
			int key2;
			while ((key2=ngetchx())!=KEY_ENTER && key2!=KEY_ESC);
			
			if (key2==KEY_ENTER)
			{
				
				clrscr();
				printf("Searching Solution... \n");
				
				SolutionsTested=0;
				SolutionFound_AI=0;
				ExitResearch=0;
				
				ChooseValue(0);
				
				printf("End of Research \n");
				GKeyFlush (); // Cancel keystrokes during searching
				ngetchx();
				
			}
					
		}
		
		else if (key==KEY_ESC)
		break;
	}
}
